package Echiquier.Piece;

import Echiquier.Case;
import Echiquier.ColorJoueur;
import Echiquier.EchiquierException;

public class Cavalier extends Piece {
    public Cavalier(Case unCase, ColorJoueur colorJoueur) {
        super(unCase, colorJoueur);
    }

    public void deplace(Case arrive) throws EchiquierException {
        //Si le deplacement est valide, activer la movement, sinon lancer exception
        if(estValide(arrive)){
            super.deplace(this,arrive);
        }else{
            deplaceInvalid(arrive);
        }
    }

    private boolean estValide(Case arrive){
        if(! super.unCase.estEuPiece()){
            return false;
        }
        //Si le case arrive a un piece de le meme joueur retourn false
        if(arrive.getPiece() != null) {
            if (super.getColorJoueur() == arrive.getPiece().getColorJoueur()) {
                return false;
            }
        }

        int ligDepart = super.getUnCase().getLig();
        int colDepart = super.getUnCase().getCol();

        int ligArrive = arrive.getLig();
        int colArrive = arrive.getCol();

        //Si le movement n'est pas un 'L' return false
        if( !(Math.abs(ligArrive - ligDepart) == 2 && Math.abs(colArrive - colDepart) == 1 ||
                Math.abs(ligArrive - ligDepart) == 1 && Math.abs(colArrive - colDepart) == 2)){
            return false;
        }

        return true;
    }
}
